structure Eval :> EVAL =
struct

  open DBMinML
  structure S = Stream


  (**** Substitution ****)

  (* shift increments the free variables in an expression *)
  (* shift : int -> exp -> exp *)
  fun shift k (Var n) = ... 
    | shift k (Fun(t,t',e)) = ...
    | shift ...







  (* subst(e',i,e) applies the substitution [e'/i] to the
     expression e, where e and the substitution are in DeBruijn 
     form *)
  (* subst : exp * var * exp -> exp *)
  fun subst ...









  (**** Evaluation ****)

  (* value(e) = true iff e is a value *)

  fun value (Int _) = true
    | value (Bool _) = true
    | value (Fun _) = true
    | value _ = false

  exception Stuck and Done

  (* step(e) = e' for some e' such that e -> e'
             = raise Stuck if no such e' exists. *)
  (* step : exp -> exp *)
  fun step ...































  fun stepOpt e = SOME (step e) handle Stuck => NONE

  fun multiStep e = multiStep (step e) handle Stuck => e

  (* Return a stream containing all the steps of an evaluation. *)

  fun stepStream e =
      let fun steps e =
              (case stepOpt e
                 of NONE => S.empty
                  | SOME e' => S.delay (fn () => S.Cons(e', steps e')))
       in S.delay (fn () => S.Cons(e, steps e)) end

end
