structure Loop :> LOOP =
struct

  type action = DBMinML.exp -> unit

  fun typing e =
          (case Typing.typeOpt e
             of SOME t => " : " ^ DBPrint.typToString t
              | NONE => " has no type.")

  (* A few actions *)

  fun show e =
      List.app print [DBPrint.expToString e, "\n"]

  fun showType e =
      List.app print [DBPrint.expToString e, typing e, "\n"]

  fun eval action e = action (Eval.multiStep e)

  fun wait action e =
      (action e;
       print "Press return:";
       TextIO.inputLine TextIO.stdIn;
       ())

  fun step action e = Stream.app action (Eval.stepStream e)


  (* Running the actions on an interactive loop or a file *)

  fun loop action =
         Stream.app action
         (Parse.parse (Lexer.lex (Input.promptkeybd "MinML> ")))

  fun loopFile name action =
         Stream.app action
         (Parse.parse (Lexer.lex (Input.readfile name)))

end
