structure Print :> NAMEDPRINT =
struct

    structure M = MinML
    type typ = M.typ
    type exp = M.exp

    exception Unimplemented (* XXXXXXXXXXXXXXXXXXXXXXX *)

    fun po M.Equal = "="
      | po M.Plus = "+"
      | po M.Minus = "-"
      | po M.Times = "*"
      | po M.Negate = "~"

    fun typToString M.INT = "int"
      | typToString M.BOOL = "bool"
      | typToString (M.ARROW(d, r)) = 
	"-> " ^ typToString d ^ " " ^ typToString r

    and expToString (M.Int i) = Int.toString i
      | expToString (M.Bool true) = "true"
      | expToString (M.Bool false) = "false"
      | expToString (M.If (ec, et, ef)) = 
	"if " ^ expToString ec ^ " then " ^
	expToString et ^ " else " ^ expToString ef ^ " fi"
      | expToString (M.Primop (p, nil)) = "(bad primop)"
      | expToString (M.Primop (p, el)) = 
	po p ^ "(" ^ 
	foldl (fn (a, b) => b ^ ", " ^ (expToString a)) 
	(expToString (hd el)) (tl el) ^ ")"
      | expToString (M.Fun (f, x, d, r, e)) = 
	"fun " ^ f ^ "(" ^ x ^ " : " ^ typToString d ^ ") : " ^
	typToString r ^ " is " ^ expToString e ^ " end"
      | expToString (M.Apply (f, e)) = 
	"(" ^ expToString f ^ " " ^ expToString e ^ ")"
      | expToString (M.Var v) = v

end

structure DBPrint :> DBPRINT =
struct

    structure M = DBMinML
    type typ = M.typ
    type exp = M.exp

    exception Unimplemented (* XXXXXXXXXXXXXXXXXXXXXXX *)

    fun po M.Equal = "="
      | po M.Plus = "+"
      | po M.Minus = "-"
      | po M.Times = "*"
      | po M.Negate = "~"

    fun typToString M.INT = "int"
      | typToString M.BOOL = "bool"
      | typToString (M.ARROW(d, r)) = 
	"-> " ^ typToString d ^ " " ^ typToString r

    and expToString (M.Int i) = Int.toString i
      | expToString (M.Bool true) = "true"
      | expToString (M.Bool false) = "false"
      | expToString (M.If (ec, et, ef)) = 
	"if " ^ expToString ec ^ " then " ^
	expToString et ^ " else " ^ expToString ef ^ " fi"
      | expToString (M.Primop (p, nil)) = "(bad primop)"
      | expToString (M.Primop (p, el)) = 
	po p ^ "(" ^ 
	foldl (fn (a, b) => b ^ ", " ^ (expToString a)) 
	(expToString (hd el)) (tl el) ^ ")"
      | expToString (M.Fun (d, r, e)) = 
	"fun _ ( _ : " ^ typToString d ^ ") : " ^
	typToString r ^ " is " ^ expToString e ^ " end"
      | expToString (M.Apply (f, e)) = 
	"(" ^ expToString f ^ " " ^ expToString e ^ ")"
      | expToString (M.Var x) = "DB[" ^ (Int.toString x) ^ "]"

end
